//! SE/Linux EHR InterProvider IDL file
#ifndef _INTERPROVIDER_ICE
#define _INTERPROVIDER_ICE

#include <ehr.ice>

module Ehr
{
  //! Interface for Interprovider communication.
  //! It works like the Provider<-->Client-Interface,
  //! except the requestor is replaced by the provider,
  //! since the provider take over the requestors role concerning the requests.
  //!
  //! We use the Request classes for code reuse reasons.
  interface InterProvider
  {
    void createPrescription(
      CreatePrescriptionRequest request,
      Signature providerSignature,
      Signature ownerSignatur
    ) throws EhrException;

    void consumePrescription(
      ConsumePrescriptionRequest request,
      Signature providerSignature,
      Signature ownerSignatur
    ) throws EhrException;

    DocumentList listDocuments(
      ListDocumentsRequest request,
      Signature providerSignature,
      Signature ownerSignatur,
      UserType requestorUsertype
    ) throws EhrException;

    DocumentList findDocuments(
      FindDocumentsRequest request,
      Signature providerSignature,
      Signature ownerSignatur,
      UserType requestorUsertype
    ) throws EhrException;
  };
};

#endif

/* vim: set et sw=2 ts=2: */
