/**
 * $Id: logger.cpp 92 2010-01-17 15:33:24Z l0728348 $
 *
 * Copyright 2009
 *
 * @author Christian, Bernhard, Manuel / Gruppe 1
 * @brief logger stuff
 */

#include "logger.h"

/* initialize ice logger */
log4cxx::LoggerPtr IceLogger::logger(log4cxx::Logger::getLogger("Ice"));

/*----------------------------------------------------------------------------*/

#ifdef NEED_LOG4CXX_TRACE

using namespace log4cxx;

IMPLEMENT_LOG4CXX_LEVEL(CustomLevel);

const LevelPtr CustomLevel::TRACE(new Level(CustomLevel::TRACE_INT, _T("TRACE"), 7));

/*----------------------------------------------------------------------------*/

LevelPtr CustomLevel::getTrace()
{
  return CustomLevel::TRACE;
}

/*----------------------------------------------------------------------------*/

const LevelPtr& CustomLevel::toLevel(int val)
{
  return toLevel(val, Level::DEBUG);
}

/*----------------------------------------------------------------------------*/

const LevelPtr& CustomLevel::toLevel(int val, const LevelPtr& defaultLevel)
{
  switch(val)
  {
    case TRACE_INT:
      return TRACE;
    default:
      return Level::toLevel(val, defaultLevel);
  }
}

/*----------------------------------------------------------------------------*/

const LevelPtr& CustomLevel::toLevel(const String& sArg)
{
  return toLevel(sArg, Level::DEBUG);
}

/*----------------------------------------------------------------------------*/

const LevelPtr& CustomLevel::toLevel(const String& sArg, const LevelPtr& defaultLevel)
{
  if (sArg.empty())
    return defaultLevel;
  String s = log4cxx::helpers::StringHelper::toUpperCase(sArg);
  if (s == (_T("TRACE")))
    return TRACE;
  return Level::toLevel(sArg, defaultLevel);
}

#endif

/* vim: set et sw=2 ts=2: */
