/**
 * $Id: ehrprovidertest.cpp 178 2010-01-30 22:56:33Z l0728348 $
 *
 * Copyright 2009
 *
 * @author Christian, Bernhard, Manuel
 * @brief Tests for ehrprovider
 */

#define BOOST_TEST_MODULE ehrprovidertest
#define BOOST_TEST_DYN_LINK
#include "redirector.h"
#include <boost/test/unit_test.hpp>

#define STRINGIFY(x) #x
#define TOSTRING(x) STRINGIFY(x)

#include "../ehrprovider.h"

char **get_argv()
{
  /* create argv inside std::vector */
  std::vector<std::string>argvvec;
  argvvec.push_back(TOSTRING(BOOST_TEST_MODULE));
  argvvec.push_back("-f" TESTCONFDIR "/" TESTCONFFILE);
  boost::optional<std::string> dbdsn;
  boost::runtime::env::get("TEST_DBDSN", dbdsn);
  if (dbdsn)
    argvvec.push_back("-odatabase.dsn=\"" + dbdsn.get() + "\"");

  /* convert to c-style const char**. this is a bit hackish */
  unsigned argc = argvvec.size();
  char **argv = new char*[argc + 2];
  for(unsigned i = 0; i < argc; ++i)
    argv[i] = strdup(argvvec[i].c_str());
  argv[argc] = NULL;

  return argv;
}

/*----------------------------------------------------------------------------*/

BOOST_AUTO_TEST_CASE(ehrprovider)
{
  EhrProvider prov;

  char **argv = get_argv();
  int argc;
  for(argc = 0; argv[argc] != NULL; ++argc);

  int ret;
  BOOST_CHECK_NO_THROW(ret = prov.setup(argc, argv));
  BOOST_CHECK(ret < 0);
}


/* vim: set et sw=2 ts=2: */

