/**
 * $Id: loggertest.cpp 145 2010-01-21 00:34:26Z l0728348 $
 *
 * Copyright 2009
 *
 * @author Christian, Bernhard, Manuel / Gruppe 1
 * @brief  Tests for configuration class
 */

#define BOOST_TEST_MODULE loggertest
#define BOOST_TEST_DYN_LINK
#include "redirector.h"
#include <boost/test/unit_test.hpp>

#include <string>
#include <utility>
#include "../configuration.h"

using namespace std;

BOOST_AUTO_TEST_SUITE(logger)

BOOST_AUTO_TEST_CASE(icelogger)
{
  IceLogger logger;
  BOOST_CHECK_NO_THROW(logger.print("some normal message"));
  BOOST_CHECK_NO_THROW(logger.trace("tracecategory", "some trace message"));
  BOOST_CHECK_NO_THROW(logger.warning("some warning message"));
  BOOST_CHECK_NO_THROW(logger.error("some error message"));
}

#if __LOG4CXX_VERSION < 1000
BOOST_AUTO_TEST_CASE(customlogger)
{
  using namespace log4cxx;

  BOOST_CHECK_EQUAL(CustomLevel::getTrace(), CustomLevel::TRACE);
  BOOST_CHECK_EQUAL(CustomLevel::toLevel(CustomLevel::TRACE_INT), CustomLevel::TRACE);
  BOOST_CHECK_EQUAL(CustomLevel::toLevel("TRACE"), CustomLevel::TRACE);

  BOOST_CHECK_EQUAL(CustomLevel::toLevel(Level::DEBUG_INT), Level::DEBUG);
  BOOST_CHECK_EQUAL(CustomLevel::toLevel(""), Level::DEBUG);
  BOOST_CHECK_EQUAL(CustomLevel::toLevel("DEBUG"), Level::DEBUG);
}
#endif

BOOST_AUTO_TEST_SUITE_END()

/* vim: set et sw=2 ts=2: */
