CREATE TYPE doc_t AS ENUM (
  'PRESCRIPTION',
  'CONSUMEDPRESCRIPTION'
);

CREATE TYPE acl_t AS ENUM (
  'ALLOW',
  'DENY'
);

CREATE TYPE user_t AS ENUM (
  'PATIENT',
  'PHARMACIST',
  'PHYSICAN'
);

CREATE TABLE users (
  id    SERIAL  PRIMARY KEY,
  name  TEXT    NOT NULL,
  type  user_t  NOT NULL
);

CREATE TABLE documents (
  id        SERIAL    PRIMARY KEY,
  userid    INTEGER   NOT NULL REFERENCES users(id) ON DELETE CASCADE,
  type      doc_t     NOT NULL,
  created   TIMESTAMP WITH time zone NOT NULL DEFAULT NOW(),
  defacl    acl_t     NOT NULL,
  valid     BOOLEAN   NOT NULL DEFAULT 'true',
  encKey    BYTEA     NOT NULL,
  initVec   BYTEA     NOT NULL,
  encData   BYTEA     NOT NULL
);

CREATE TABLE permissions (
  id        SERIAL   PRIMARY KEY,
  docid     INTEGER  NOT NULL REFERENCES documents(id) ON DELETE CASCADE,
  username  TEXT     NOT NULL,
  provider  TEXT     NOT NULL,
  acl       acl_t    NOT NULL
);
